(function( $ ) {

	$(document).ready(function() {

		$('.welaunch-select2').select2();

		// on upload button click
		$('body').on( 'click', '.wordpress-form-wizard-upload-image', function(e){

			e.preventDefault();

			var button = $(this),
			custom_uploader = wp.media({
				title: 'Insert image',
				library : {
					// uploadedTo : wp.media.view.settings.post.id, // attach to the current post?
					type : 'image'
				},
				button: {
					text: 'Use this image' // button label text
				},
				multiple: false
			}).on('select', function() { // it also has "open" and "close" events
				var attachment = custom_uploader.state().get('selection').first().toJSON();
				button.find('img').attr('src', attachment.url);
				button.find('input').val(attachment.id).trigger('change');
			}).open();
		
		});

		// on remove button click
		$('body').on('click', '.wordpress-form-wizard-remove-image', function(e){

			e.preventDefault();

			var button = $(this);
			button.prev().find('input').val('').trigger('change'); // emptying the hidden field
			button.prev().find('img').attr('src', form_wizard_options.placeholder_image_src);
		});


		$('.wordpress-form-wizard-depdencies').on('click', '.wordpress-form-wizard-depdencies-add-dependency', function(e) {

			e.preventDefault();

			$(this).parents('.wordpress-form-wizard-depdencies').find('.wordpress-form-wizard-depdencies-dependency-hidden').first().removeClass('wordpress-form-wizard-depdencies-dependency-hidden')
		});


		$('body').on('change', '.wordpress-form-wizard-taxonomies-taxonomy-name', function(e){

			e.preventDefault();

			var $this = $(this);
			var taxonomy = $this.val();
			if(taxonomy == "") {
				return;
			}

			jQuery.ajax({
				url: ajaxurl,
				type: 'post',
				dataType: 'JSON',
				data: {
					action: 'wordpress_form_wizard_get_terms',
					taxonomy: taxonomy,
				},
				success : function( response ) {				

					var options = '<option value="">Select Terms</option>';
					if(response.data) {
						$.each(response.data, function(i, index) {
							options += '<option value="' + i + '">' + index + '</option>';
						});
					}

					var valuesElement = $this.parent().parent().find('.wordpress-form-wizard-taxonomies-taxonomy-values');
					valuesElement.html(options);
					valuesElement.select2();

				},
				error: function(jqXHR, textStatus, errorThrown) {
				    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
				}
			});
		});

		$('body').on('change', '.wordpress-form-wizard-depdencies-dependency-question', function(e){

			e.preventDefault();

			var $this = $(this);
			var questionId = $this.val();
			if(questionId == "") {
				return;
			}

			jQuery.ajax({
				url: ajaxurl,
				type: 'post',
				dataType: 'JSON',
				data: {
					action: 'wordpress_form_wizard_get_answers',
					questionId: questionId,
				},
				success : function( response ) {				

					var options = '<option value="">Select Answers</option>';
					$.each(response.data, function(i, index) {
						options += '<option value="' + i + '">' + index + '</option>';
					});

					var valuesElement = $this.parent().parent().find('.wordpress-form-wizard-depdencies-dependency-values');
					valuesElement.html(options);
					valuesElement.select2();

				},
				error: function(jqXHR, textStatus, errorThrown) {
				    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
				}
			});
		});

		var postTypeCheck = $('body.post-type-wizard_question');
		if(postTypeCheck.length > 0) {

			$('body').on('click', '.wordpress-form-wizard-actions-add-answer', function(e){

				e.preventDefault();

				var answer = prompt(form_wizard_options.promptsAnswer, "");
				if(!answer || answer == "") {
					return false;
				}

				var postId = $('#post_ID').val();

				jQuery.ajax({
					url: ajaxurl,
					type: 'post',
					dataType: 'JSON',
					data: {
						action: 'wordpress_form_wizard_add_answer',
						postId: postId,
						answer: answer,
					},
					success : function( response ) {

						if(response.status == 0) {
							alert(response.message);
							return false;
						}						

						var template = $('.wordpress-form-wizard-answers-answer-template').clone();

						var index = template.data('index');
						var newIndex = index + 1;

						template.find('input, textarea, select').each(function() {

							var attrName = $(this).attr('name');
							if(typeof attrName == "undefined" || attrName == "") {
								return true;
							}
							console.log(attrName);
							console.log($(this));
							$(this).attr('name', $(this).attr('name').replace(/\[\d+](?!.*\[\d)/, '[' + response.data.id + ']') );
							$(this).attr('name', $(this).attr('name').replace('INDEX', '0' ) );
						});


						template.removeClass('wordpress-form-wizard-answers-answer-template');
						template.find('.wordpress-form-wizard-answers-answer-id').val(response.data.id);
						template.find('.wordpress-form-wizard-answers-answer-name input').val(response.data.title);
						template.find('.wordpress-form-wizard-answers-answer-actions-hide').data('id', response.data.id)
						template.css('display', 'block');

						template.find('.welaunch-select2').select2();

						$('.wordpress-form-wizard-answers').append(template).show();
						
					},
					error: function(jqXHR, textStatus, errorThrown) {
					    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
					}
				});
			});

			$('body').on('click', '.wordpress-form-wizard-answers-answer-actions-hide', function(e){

				e.preventDefault();

				var $this = $(this);
				var answer = $this.data('id');

				jQuery.ajax({
					url: ajaxurl,
					type: 'post',
					dataType: 'JSON',
					data: {
						action: 'wordpress_form_wizard_hide_answer',
						answer: answer,
					},
					success : function( response ) {

						if(response.status == 0) {
							alert(response.message);
							return false;
						}

						$this.removeClass('wordpress-form-wizard-answers-answer-actions-hide').addClass('wordpress-form-wizard-answers-answer-actions-show');
						$this.parents('.wordpress-form-wizard-answers-answer').addClass('wordpress-form-wizard-answers-answer-disabled');
						
					},
					error: function(jqXHR, textStatus, errorThrown) {
					    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
					}
				});
			});

			$('body').on('click', '.wordpress-form-wizard-answers-answer-actions-show', function(e){

				e.preventDefault();

				var $this = $(this);
				var answer = $this.data('id');

				jQuery.ajax({
					url: ajaxurl,
					type: 'post',
					dataType: 'JSON',
					data: {
						action: 'wordpress_form_wizard_show_answer',
						answer: answer,
					},
					success : function( response ) {

						if(response.status == 0) {
							alert(response.message);
							return false;
						}

						$this.removeClass('wordpress-form-wizard-answers-answer-actions-show').addClass('wordpress-form-wizard-answers-answer-actions-hide');
						$this.parents('.wordpress-form-wizard-answers-answer').removeClass('wordpress-form-wizard-answers-answer-disabled');
						
					},
					error: function(jqXHR, textStatus, errorThrown) {
					    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
					}
				});
			});

			var postId = $('#post_ID').val();

			$('.wordpress-form-wizard-posts').select2({
                placeholder :'Select item ...',
                ajax: {
                method: "POST",
                dataType: 'json',
                delay: 250, // wait 250 milliseconds before triggering the request
                url: ajaxurl,
                minimumInputLength: 1,
                data: function (params) {
                  var query = {
                    search: params.term,
                    action: 'wordpress_form_wizard_search_posts',
                    postId: postId,
                  }

                  // Query parameters will be ?search=[term]&type=public
                  return query;
                },
                processResults: function (data) {
                    return {
                        results: $.map(data.items, function (item) {
                            return {
                                text: item.text,
                                id: item.id
                            }
                        })
                    };
                }
              }
            }).trigger('change');


			$('.wordpress-form-wizard-answers').sortable({
				placeholder: "sortable-placeholder",
			  	forcePlaceholderSize: true,
				update: function() {

					var answerIds = [];
					$('.wordpress-form-wizard-answers .wordpress-form-wizard-answers-answer-id').each(function(i, index) {
						answerIds.push($(this).val());
					});

					jQuery.ajax({
						url: ajaxurl,
						type: 'post',
						dataType: 'JSON',
						data: {
							action: 'wordpress_form_wizard_sort_answers',
							postId: postId,
							answerIds: answerIds,
						},
						success : function( response ) {

							if(response.status == 0) {
								alert(response.message);
								return false;
							}						
						},
						error: function(jqXHR, textStatus, errorThrown) {
						    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
						}
					});
					
				}
			})
		}

		var postTypeCheck = $('body.post-type-wizard_form');
		if(postTypeCheck.length > 0) {

			$('body').on('click', '.wordpress-form-wizard-actions-add-question', function(e){

				e.preventDefault();

				var question = prompt( form_wizard_options.promptsQuestion , "");
				if(!question || question == "") {
					return false;
				}

				var postId = $('#post_ID').val();

				jQuery.ajax({
					url: ajaxurl,
					type: 'post',
					dataType: 'JSON',
					data: {
						action: 'wordpress_form_wizard_add_question',
						postId: postId,
						question: question,
					},
					success : function( response ) {

						if(response.status == 0) {
							alert(response.message);
							return false;
						}

						var template = $('.wordpress-form-wizard-questions-question-template').clone();
						template.removeClass('wordpress-form-wizard-questions-question-template');
						template.find('.wordpress-form-wizard-questions-question-id').val(response.data.id);
						template.find('.wordpress-form-wizard-questions-question-name').text(response.data.title);
						template.find('.wordpress-form-wizard-questions-question-actions-edit').attr('href', form_wizard_options.admin_url + 'post.php?post=' + response.data.id + '&action=edit')
						template.find('.wordpress-form-wizard-questions-question-actions-hide').data('id', response.data.id)
						template.css('display', 'block');

						$('.wordpress-form-wizard-questions').append(template).show();
					},
					error: function(jqXHR, textStatus, errorThrown) {
					    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
					}
				});
			});

			$('body').on('click', '.wordpress-form-wizard-questions-question-actions-hide', function(e){

				e.preventDefault();

				var $this = $(this);
				var question = $this.data('id');

				jQuery.ajax({
					url: ajaxurl,
					type: 'post',
					dataType: 'JSON',
					data: {
						action: 'wordpress_form_wizard_hide_question',
						question: question,
					},
					success : function( response ) {

						if(response.status == 0) {
							alert(response.message);
							return false;
						}

						$this.removeClass('wordpress-form-wizard-questions-question-actions-hide').addClass('wordpress-form-wizard-questions-question-actions-show');
						$this.parents('.wordpress-form-wizard-questions-question').addClass('wordpress-form-wizard-questions-question-disabled');
						
					},
					error: function(jqXHR, textStatus, errorThrown) {
					    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
					}
				});
			});

			$('body').on('click', '.wordpress-form-wizard-questions-question-actions-show', function(e){

				e.preventDefault();

				var $this = $(this);
				var question = $this.data('id');

				jQuery.ajax({
					url: ajaxurl,
					type: 'post',
					dataType: 'JSON',
					data: {
						action: 'wordpress_form_wizard_show_question',
						question: question,
					},
					success : function( response ) {

						if(response.status == 0) {
							alert(response.message);
							return false;
						}

						$this.removeClass('wordpress-form-wizard-questions-question-actions-show').addClass('wordpress-form-wizard-questions-question-actions-hide');
						$this.parents('.wordpress-form-wizard-questions-question').removeClass('wordpress-form-wizard-questions-question-disabled');
						
					},
					error: function(jqXHR, textStatus, errorThrown) {
					    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
					}
				});
			});

			$('.wordpress-form-wizard-questions').sortable({
				placeholder: "sortable-placeholder",
			  	forcePlaceholderSize: true,
				update: function() {

					var postId = $('#post_ID').val();
					var questionIds = [];
					$('.wordpress-form-wizard-questions input').each(function(i, index) {
						questionIds.push($(this).val());
					});

					jQuery.ajax({
						url: ajaxurl,
						type: 'post',
						dataType: 'JSON',
						data: {
							action: 'wordpress_form_wizard_sort_questions',
							postId: postId,
							questionIds: questionIds,
						},
						success : function( response ) {

							if(response.status == 0) {
								alert(response.message);
								return false;
							}						
						},
						error: function(jqXHR, textStatus, errorThrown) {
						    console.log('An Error Occured: ' + jqXHR.status + ' ' + errorThrown + '! Please contact System Administrator!');
						}
					});
					
				}
			});
		}
	});

})( jQuery );
